/**
 * generated by Xtext 2.25.0
 */
package tdt4250.xjava;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Type Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tdt4250.xjava.TypeReference#getTypeName <em>Type Name</em>}</li>
 *   <li>{@link tdt4250.xjava.TypeReference#getTypeParameters <em>Type Parameters</em>}</li>
 * </ul>
 *
 * @see tdt4250.xjava.XjavaPackage#getTypeReference()
 * @model
 * @generated
 */
public interface TypeReference extends EObject
{
  /**
   * Returns the value of the '<em><b>Type Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type Name</em>' attribute.
   * @see #setTypeName(String)
   * @see tdt4250.xjava.XjavaPackage#getTypeReference_TypeName()
   * @model
   * @generated
   */
  String getTypeName();

  /**
   * Sets the value of the '{@link tdt4250.xjava.TypeReference#getTypeName <em>Type Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type Name</em>' attribute.
   * @see #getTypeName()
   * @generated
   */
  void setTypeName(String value);

  /**
   * Returns the value of the '<em><b>Type Parameters</b></em>' containment reference list.
   * The list contents are of type {@link tdt4250.xjava.TypeReference}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type Parameters</em>' containment reference list.
   * @see tdt4250.xjava.XjavaPackage#getTypeReference_TypeParameters()
   * @model containment="true"
   * @generated
   */
  EList<TypeReference> getTypeParameters();

} // TypeReference
